!----------------------------------------------------------------!
! The current code has the purpose:                              !
! (1) demonstrate data racing issues.                            !
!----------------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                        !
! March 17, 2016                                                 !
!----------------------------------------------------------------!

      program data_racing
      implicit none
      integer            :: i,nosize
      integer, parameter :: nsize = 10
      integer, dimension(0:nsize-1) :: array_org,array_a

      nosize = nsize
      do i = 0, nosize-1
         array_org(i) = dble(i)
      end do

      array_a = array_org


!$omp parallel do default(none) private(i) shared(nosize,array_a)
      do i = 1, nosize-1
         array_a(i) = array_a(i) + array_a(i-1)
      end do
!$omp end parallel do

      do i = 0, nosize-1
         write(*,'(1x,a,i2,a,i4)')   'array_a( ',i,' ) = ', array_a(i)
      end do


      write(*,*)
      write(*,*)


! restore array_a:
      array_a = array_org


!------------------------------------------------------------!
!---  do we have data dependences in the following loop?  ---!
!------------------------------------------------------------!

!$omp parallel do default(none) private(i) shared(nosize,array_a)
      do i = 1, nosize-1, 2
         array_a(i) = array_a(i) + array_a(i-1)
      end do
!$omp end parallel do

      do i = 0, nosize-1
         write(*,'(1x,a,i2,a,i4)')   'array_a( ',i,' ) = ', array_a(i)
      end do


      end program data_racing

!----------------------------------------------------!
! The current code has the purpose:                  !
! (1) how to use single blocks.                      !
!----------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                            !
! March 17, 2016                                     !
!----------------------------------------------------!

      program single_f
      implicit none
      integer            :: i,j,k,id,omp_get_thread_num
      integer, parameter :: idp = 8, nsize_a = 800, nsize_b = 200
      real(kind=idp)     :: temp,time_start,time_end,omp_get_wtime
      real(kind=idp), dimension(1:nsize_a,1:nsize_a,1:nsize_a) :: array_a
      real(kind=idp), dimension(1:nsize_b,1:nsize_b)           :: array_b


      time_start = omp_get_wtime()

!$omp parallel

!$omp single
      id = omp_get_thread_num()
      write(*,*) 'single block 1. My id is ', id
      do i = 1, nsize_a
      do j = 1, nsize_a
      do k = 1, nsize_a
         temp = SIN(dble(i+j+k))
         array_a(k,j,i) = EXP(temp)
      end do
      end do
      end do
!$omp end single

!$omp single
      id = omp_get_thread_num()
      write(*,*) 'single block 2. My id is ', id
      do i = 1, nsize_b
      do j = 1, nsize_b
         temp = SIN(dble(i+j))
         array_b(j,i) = EXP(temp)
      end do
      end do
!$omp end single


!$omp end parallel


      time_end = omp_get_wtime()

      write(*,*) 'elapsed time (seconds) = ', time_end - time_start
      write(*,*)


      end program single_f

!----------------------------------------------------------------!
! The current code has three purpose:                            !
! (1) how to parallalize nested loops.                           !
! (2) matrix-matrix product.                                     !
! (3) algorithm's importance.                                    !
!----------------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                        !
! March 17, 2016                                                 !
!----------------------------------------------------------------!

      program nested_loops_v2
      implicit none
      integer            :: i,j,k,nosize
      integer, parameter :: idp = 8, nsize = 6000
      real(kind=idp)     :: temp,time_start,time_end,omp_get_wtime
      real(kind=idp), dimension(1:nsize,1:nsize) :: a,b,c


      nosize = nsize
! initialize arrays: a, b, and c:
      do i = 1, nosize
      do j = 1, nosize
         a(j,i) = SIN( dble(i-j) )
         b(j,i) = COS( dble(i+j) )
      end do
      end do

      c = 0.0_idp


! c = a x b 

      time_start = omp_get_wtime()

! only parallelize the outer loop in jki:
!$omp parallel do default(none) private(i,j,k) shared(nosize,a,b,c)
      do j = 1, nosize
      do k = 1, nosize
         do i = 1, nosize
            c(i,j) = c(i,j) + a(i,k) * b(k,j)
         end do
      end do
      end do
!$omp end parallel do

      time_end = omp_get_wtime()

      write(*,*) 'elapsed time (seconds) = ', time_end - time_start
      write(*,*)

!----------------------------------------------------------------------------!




      end program nested_loops_v2

!-------------------------------------------------------!
! The current code has two purposes:                    !
! (1) Using Intel and PGI compilers and see how         !
!     OMP_NUM_THREADS was set by default.               !  
! (2) Demonstrate how private variables behave outside  !
!     of parallell regions.                             !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 07, 2016                                        !
!-------------------------------------------------------!

      program privatevar
      implicit none
      integer   :: k,id,nothread,omp_get_num_threads,omp_get_thread_num


!$omp parallel private (k,id)
       nothread = omp_get_num_threads() 
       id = omp_get_thread_num()
       k = id + id
!$omp end parallel


       write(*,*) 'Hello from the master. k = ', k


!$omp parallel private (k,id)
       write(*,*) 'Hello: ', id, k, nothread
!$omp end parallel


      end program privatevar

!-------------------------------------------------------!
! The current code has a purpose:                       !
! (1) how to use atomic (critical) directive.           !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 07, 2016                                        !
!-------------------------------------------------------!

      program atomic
      implicit none
      integer, parameter  :: idp=8,nsize = 1000
      integer ::  i,id,omp_get_thread_num,nothread,omp_get_num_threads
      real(kind=idp)  :: x, answer



!$omp parallel private (i) shared(x)
!$omp do
      do i = 0, nsize-1
!$omp atomic
         x = x + dble(i)
      end do
!$omp end do
!$omp end parallel

      answer = 0.5_idp * (nsize-1)*nsize
      write(*,'(a,f10.2)') 'parallel sum is ',x
      write(*,'(a,f10.2)') 'correct answer is ', answer


      end program atomic

!----------------------------------------------------------------!
! The current code has the purpose:                              !
! (1) demonstrate firstprivate variables.                        !
! (2) reduction variables.                                       !
!----------------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                        !
! March 17, 2016                                                 !
!----------------------------------------------------------------!

      program first_private
      implicit none
      integer            :: i,id,nosize,noprocs,omp_get_num_procs,omp_get_thread_num
      integer, parameter :: idp = 8,nsize = 50
      real(kind=idp), dimension(0:nsize-1) :: array_a
      real(kind=idp)     :: temp,tsum,totsum


      noprocs = omp_get_num_procs()

      nosize = nsize
      do i = 0, nosize-1
         array_a(i) = dble(i)
      end do


         tsum = 0.0_idp
         totsum = 0.0_idp

!$omp parallel default(none) private(id,i) shared(nosize,noprocs,array_a)  &
!$omp firstprivate(tsum) reduction(+: totsum)

      id = omp_get_thread_num()

!$omp do 
      do i = 0, nosize-1
         tsum = tsum + array_a(i)
      end do
!$omp end do
      write(*,'(1x,i3,3x,f12.2)') id, tsum

!$omp do schedule(static,1)
      do i = 0, noprocs-1
         totsum = totsum + tsum 
      end do
!$omp end do
!$omp end parallel

      write(*,*)
      write(*,'(1x,a,f12.2)') 'totsum = ',totsum
      write(*,'(1x,a,f12.2)') 'correct answer = ', 0.5_idp*nosize*(nosize-1)

      end program first_private

!-------------------------------------------------------!
! The current code has two purposes:                    !
! (1) using Intel and PGI compilers and see how         !
!     OMP_NUM_THREADS was set by default.               !  
! (2) demonstrate how private variables behave outside  !
!     of parallell regions.                             !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 07, 2016                                        !
!-------------------------------------------------------!

      module thpr
      implicit none
      integer            :: id,istart,iend
      integer, parameter :: idp = 8, nsize = 410 
      real(kind=idp) :: array_a(1:nsize),array_b(1:nsize),array_c(1:nsize)
      end module thpr


      program threadprivate_v0
      use thpr
      implicit none
      integer   :: i,nothread,nchunk,omp_get_num_threads,omp_get_thread_num

         array_c = 0.0_idp
      do i = 1, nsize
         array_a(i) = dble(i)
         array_b(i) = dble(i+i)
      end do


!$omp parallel private (id,nchunk,istart,iend)
         nothread = omp_get_num_threads() 
         id = omp_get_thread_num()
         nchunk = dble(nsize)/dble(nothread)
         istart = 1 + id*nchunk
         iend = istart + nchunk - 1
      if(id == nothread-1) then
         istart = 1 + id*nchunk
         iend = nsize
         nchunk = iend - istart + 1
         write(*,'(1x,a,3(i3,3x))') 'Hello from ', id, istart, iend
      end if
!$omp end parallel


      write(*,'(1x,a,i3)') 'Hello I am master. id = ', id


!$omp parallel private (id,istart,iend)
      write(*,'(1x,a,3(i3,3x))') 'Hello from ',id, istart,iend
!$omp end parallel


      end program threadprivate_v0

!----------------------------------------------------!
! The current code has the purpose:                  !
! (1) how to run multiple sections.                  !
!----------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                            !
! March 17, 2016                                     !
!----------------------------------------------------!

      program sections_f
      implicit none
      integer            :: i,j,k,id,omp_get_thread_num
      integer, parameter :: idp = 8, nsize_a = 20000, nsize_b = 40000, nsize_c = 2000
      real(kind=idp)     :: temp,time_start,time_end,omp_get_wtime
      real(kind=idp), dimension(0:nsize_a-1,0:nsize_a-1) :: array_a
      real(kind=idp), dimension(0:nsize_b-1,0:nsize_b-1) :: array_b
      real(kind=idp), dimension(0:nsize_c-1) :: array_c



      time_start = omp_get_wtime()

!$omp parallel sections

!$omp section
      id = omp_get_thread_num()
      write(*,*) 'section 1. My id is ', id
      do i = 0, nsize_a-1
      do j = 0, nsize_a-1
         temp = SIN(dble(i+j))
         array_a(j,i) = EXP(temp)
      end do
      end do

      write(*,'(a,f9.6)')  'The last array_a element = ', array_a(nsize_a-1,nsize_a-1)

!!$omp section
!      id = omp_get_thread_num()
!      write(*,*) 'section 2. My id is ', id
!      do i = 0, nsize_b-1
!      do j = 0, nsize_b-1
!         temp = SQRT(dble(i+j))
!         array_b(j,i) = COS(temp) -SIN(temp)
!      end do
!      end do
!
!      write(*,'(a,f9.6)')  'The last array_b element = ', array_b(nsize_b-1,nsize_b-1)
!
!!$omp section
!      id = omp_get_thread_num()
!      write(*,*) 'section 3. My id is ', id
!      do i = 0, nsize_c-1
!        temp = SIN(dble(i)) - COS(dble(i))
!         array_c(i) = EXP(temp)
!      end do
!
!      write(*,'(a,f9.6)') 'The last array_c element = ',array_c(nsize_c-1)

!$omp end parallel sections


      time_end = omp_get_wtime()

      write(*,*) 'elapsed time (seconds) = ', time_end - time_start
      write(*,*)


      end program sections_f

!-------------------------------------------------------!
! The current code has three purposes:                  !
! (1) how loop iterations are mapped to threads.        !  
! (2) demonstrates the work-sharing in parallel region. !
! (3) work-sharing does not spawn multiple threads.     !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 07, 2016                                        !
!-------------------------------------------------------!

      program mapping_threads
      implicit none
      integer ::  i,id,omp_get_thread_num,nothread,omp_get_num_threads
      integer, parameter :: nsize = 40

!$omp parallel private (id,i) shared(nothread)
      id = omp_get_thread_num()
      nothread = omp_get_num_threads()
!!      write(*,'(1x,a,i3,a,i3)') &
!!     &   "Hello World! from ID ", id, " out of ", nothread
!$omp do
      do i = 1, nsize
         write(*,'(1x,2(a,i4))') "id = ",id, " i = ",i
      end do
!$omp end do
!$omp end parallel

      end program mapping_threads

!-------------------------------------------------------!
! The current code has three purposes:                  !
! (1) a simple parallel region.                         !  
! (2) private and shared variables.                     !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 07, 2016                                        !
!-------------------------------------------------------!

      program hello_world
      implicit none
      integer ::  id,omp_get_thread_num, omp_get_num_procs,noprocs

!$omp parallel private(id,noprocs)
      id = omp_get_thread_num()
      noprocs = omp_get_num_procs()
      write(*,'(1x,a,i3,2x,i3)') "Hello World! from ", id, noprocs
!$omp end parallel

      end program hello_world

!----------------------------------------------------------------!
! The current code has the purpose:                              !
! (1) use threadprivate variable in the different program units. !
!----------------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                        !
! March 17, 2016                                                 !
!----------------------------------------------------------------!
      module thpr
      implicit none
      integer             :: id,istart,iend
      integer, parameter  :: idp = 8, nsize = 410 
      real(kind=idp)      :: array_a(0:nsize-1),array_b(0:nsize-1),array_c(0:nsize-1)
!$omp threadprivate (id,istart,iend)
      end module thpr


      program threadprivate_v2
      use thpr
      implicit none
      integer         :: i,nothread,nchunk,omp_get_num_threads,omp_get_thread_num
      real(kind=idp)  :: diff
      real(kind=idp), dimension(0:nsize-1) :: array_master

         array_c = 0.0_idp
      do i = 1, nsize
         array_a(i) = dble(i)
         array_b(i) = dble(i+i)
      end do


!$omp parallel 
         nothread = omp_get_num_threads() 
         id = omp_get_thread_num()
         nchunk = dble(nsize)/dble(nothread)
         istart = id*nchunk
         iend = istart + nchunk - 1
      if(id == nothread-1) then
         istart = id*nchunk
         iend = nsize-1
         nchunk = iend - istart + 1
         write(*,'(1x,a,3(i3,3x))') 'Hello from ', id, istart, iend
      end if
!$omp end parallel


      write(*,'(1x,a,i3)') 'Hello I am master. id = ', id


!$omp parallel
      call scalar
!$omp end parallel


! check the results:
      do i = 0, nsize-1
         array_master(i) = array_a(i) + array_b(i)
         diff = ( array_master(i) - array_c(i) ) / array_master(i)
         if( ABS(diff) >= 1.d-10 ) then 
             write(*,'(1x,a)') 'Error seems too large!'
             write(*,'(1x,a,i4,a,es12.5,3x,2(es12.5,3x))')   &
     &            'i = ',i, ' diff = ', diff, array_master(i), array_c(i)
         end if
      end do


      end program threadprivate_v2



!--------------------------------------------------!
! this routine needs to be called by all threads.  !
!--------------------------------------------------!
      subroutine scalar
      use thpr
      implicit none
!omp threadprivate(id,istart,iend)
      integer :: i

! each thread only works on its own chunk of arrays.
      write(*,'(1x,a,3x,3(a,i3,3x))')  'from scalar rotune.',  & 
     &      "id = ", id, "istart = ", istart, "iend = ", iend

      do i = istart, iend
         array_c(i) = array_a(i) + array_b(i)
      end do

      return
      end subroutine
